/*!
	@brief	MIDI parsing library configuration header

	@file	midi_conf.h
	@author	Satoshi "Chuck" Takagi
	@date	2009/08/29
 */

// ---- single uart port device ----
#include "../uart.h"

#ifdef MIDI_BAUD_RATE
#undef MIDI_BAUD_RATE
#endif
#define MIDI_BAUD_RATE 31250

#ifdef UART_BAUD_SELECT
#undef UART_BAUD_SELECT
#endif
#define UART_BAUD_SELECT (F_CPU/(MIDI_BAUD_RATE*16l)-1)

#define midiUartInit() uart_init()
#define midiUartGetByte() uart_getchar()
#define midiUartSendByte(x) uart_putchar(x)
// ---- single uart port device ----


#ifdef NOUSE
// ----- dual uart port device -----
#include "../uart2.h"

#define midiUartInit() uart0Init();uartSetBaudRate(0,MIDI_BAUD_RATE)
//#define midiUartInit() uart1Init();uartSetBaudRate(1,MIDI_BAUD_RATE)

#define midiUartGetByte() uart0GetByte()
// #define midiUartGetByte() uart1GetByte()
// ----- dual uart port device -----
#endif


// -- MIDI message configurations --
#define USE_MIDI_CC
// -- MIDI message configurations --

// #define PRESERVE_NOTEON_VELOCITY

// MIDI Legato store size, upto 16
#define MIDI_LEGATO_MEMSIZ 0
