/*
 * mboxb.c
 *
 * Created: 2013/11/02 16:17:40
 *  Author: Chuck
 */ 


#include <avr/io.h>

#include <inttypes.h>
#include <avr/io.h>
//#include <avr/wdt.h>
#include <avr/interrupt.h>
#include "config/midi_conf.h"
#include "global.h"
#include "uart.h"
#include "midi.h"

/*
uint8_t mcusr_mirror;
void get_mcusr(void) \
__attribute__((naked)) \
__attribute__((section(".init3")));

void get_mcusr(void)
{
	mcusr_mirror = MCUSR;
	MCUSR = 0;
	wdt_disable();
}
*/

struct MIDI_SystemMessage MidiSystemMessage;
struct MIDI_ChannelMessage MidiChannelMessage;

static uint8_t midich_rx;
static uint8_t midich_tx;
static uint8_t midi_rt;


ISR(INT0_vect)
{

	uint8_t tmpd;

	tmpd = ~PIND;
	if (tmpd & (1<<PD2))
		MidiSystemMessage.Status |= fMidiStart;
	else
		MidiSystemMessage.Status |= fMidiStop;

}

ISR(INT1_vect)
{
	MidiSystemMessage.Status |= fMidiTimingClock;
}
	


static void ioinit (void)
{
	// input settings
	PORTB = 0xFF;
	DDRB = 0x00;	// port B: input w/ pull-up
	PORTD = (1<<DDD6); // PD6 as input w/ pull-up
	DDRD = (1<<DDD1); // only PD1 assigned as output, TXD

	// no timer user
//	TCCR0B = (1<<CS00);
//	TCCR1B = (1<<WGM12)|(1<<CS10);
//	TIMSK = (1<<TOIE1);

	// External INT0/1
	//   INT0 : logical change
	//   INT1 : rising edge
	MCUCR = (1<<ISC11)|(1<<ISC10)|(0<<ISC01)|(1<<ISC00);
	GIMSK = (1<<INT1)|(1<<INT0);

//	wdt_enable(WDTO_4S);
}

static void MyMidiInit(void)
{
	uint8_t tmpb, tmpd;

	tmpb = ~PINB;
	tmpd = ~PIND;
	midich_rx = tmpb & 0x0F;
	midich_tx = (tmpb & 0xF0) >> 4;
	midi_rt = (tmpd & 0x40) ? 1 : 0;

	MidiSystemMessage.Status = 0;
	MidiChannelMessage.Status = 0;
}

int main(void)
{
	ioinit();
	MidiInit();
	MyMidiInit();

	sei();
	for (;;) {

		MidiParse();
		if (MidiSystemMessage.Status)
			if (midi_rt)
				MidiSendSystemMsg();
			else
				MidiSystemMessage.Status = 0;
		if (MidiChannelMessage.Status) {
			if (MidiChannelMessage.Channel == midich_rx) {
				MidiChannelMessage.Channel = midich_tx;	
				MidiSendChannelMsg();
			} else {
				MidiChannelMessage.Status = 0;
			}
		}
			
	}



	return 0;
}
